if(WIN32)
    if(CMAKE_SIZEOF_VOID_P EQUAL 8)
        set(LIBEXPAT_DIR ${CMAKE_SOURCE_DIR}/Toolkits/expat/lib/windows/x64)
    elseif(CMAKE_SIZEOF_VOID_P EQUAL 4)
        set(LIBEXPAT_DIR ${CMAKE_SOURCE_DIR}/Toolkits/expat/lib/windows/win32)
    endif()
    target_link_libraries(${TARGET} PRIVATE ${LIBEXPAT_DIR}/libexpatMT$<$<CONFIG:Debug>:d>.lib)
elseif(CMAKE_COMPILE_FOR_ANDROID)
    target_link_libraries(${TARGET} PRIVATE ${CMAKE_SOURCE_DIR}/Toolkits/Android/bin/${CMAKE_ANDROID_API_LEVEL}/armeabi-v7a/libexpat.so)
elseif(UNIX)
    if(CMAKE_CROSSCOMPILING AND MVIMPACT_ACQUIRE_TOOLCHAIN_PATH)
        if(CMAKE_SYSTEM_PROCESSOR STREQUAL "arm64")
            target_link_libraries(${TARGET} PRIVATE ${CMAKE_SOURCE_DIR}/Toolkits/expat/bin/arm64/lib/libexpat.so)
        elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL "armhf")
            target_link_libraries(${TARGET} PRIVATE ${CMAKE_SOURCE_DIR}/Toolkits/expat/bin/armhf/lib/libexpat.so)
        elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL "armsf")
            target_link_libraries(${TARGET} PRIVATE ${CMAKE_SOURCE_DIR}/Toolkits/expat/bin/armsf/lib/libexpat.so)
        elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL "i686")
            target_link_libraries(${TARGET} PRIVATE ${CMAKE_SOURCE_DIR}/Toolkits/expat/bin/x86/lib/libexpat.so)
        elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64")
            target_link_libraries(${TARGET} PRIVATE ${CMAKE_SOURCE_DIR}/Toolkits/expat/bin/x86_64/lib/libexpat.so)
        else()
            target_link_libraries(${TARGET} PRIVATE expat)
        endif()
    else()
        target_link_libraries(${TARGET} PRIVATE expat)
    endif()
endif()
